;***************************************************************************
;* project         : MAHPONG 	                                           *
;*-------------------------------------------------------------------------*
;* program         : character genrator submodule				   *
;***************************************************************************
;* file            : chargen.inc                              		   *
;* version         : 1.0a                                                  *
;*-------------------------------------------------------------------------*
;* original Date   : 03.05.17    Author: M. Hasenstab                      *
;*                 :                     marcus.hasenstab@jkdesign.de      *
;*-------------------------------------------------------------------------*
;* last change     : 03.05.17    Author: MAH		                   *
;***************************************************************************
;* destination HW  : 8515 plus 2bitvideo DAC	                           *
;* destination SW  : 						           *
;* assembler       : wavrasm					           *
;* language        : assembler for AVR		                           *
;***************************************************************************
;*                      COPYRIGHT (c)  				           *
;***************************************************************************



;***************************************************************************
;* Draw 3x5 digit                                                          *
;*
;* the lower 2 bits of the x coordinate are ignored
;* 
;*	;ldi	TMP, color
;* 	;mov	LREG1, TMP
;* 	ldi	VREG1, x
;* 	ldi	VREG2, y
;* 	ldi	TMP, char
;* 	rcall	DRAWDIGIT35
;***************************************************************************
DRAWDIGIT35:
	push	YL
	push	YH
	push	ZL
	push	ZH
	push	TMPL
	push	TMPH

; check entry values
;	cpi	VREG1, 45		; x-max -> no x-max-> to get the first columns
;	brge	DRAWDIGIT35_END
	cpi	VREG2, 4		; y-min
	brlt	DRAWDIGIT35_END
	cpi	TMP, 10		; digit max+1
	brge	DRAWDIGIT35_END
; calc coords	;ByteAdresse = Y*12 + (X/4) + 1 + Bildschirmspeicher
	subi	VREG2, 4
	push	TMP
	rcall	CALCPIXEL		; puts upper left digit corner in Y
	pop	TMP

	subi	YL, 1			; to get left border
	sbc	YH, ZEROREG
	
;	ldi	YL,  low((VIDEOBASE)+1)	; 
;	ldi	YH, high((VIDEOBASE)+1)
	
	
; copy digit
	ldi	ZL,  low(DIGIT35_0*2)	; calc digit memory offset int Z
	ldi	ZH, high(DIGIT35_0*2)
	mov	TMPL, TMP		; TMP*6 (6bytes per digit)
	lsl	TMPL
	lsl	TMPL
	add	TMPL, TMP
	add	TMPL, TMP
	add	ZL, TMPL
	adc	ZH, ZEROREG

	clr	TMPL			; copy digit 5 lines
DRAWDIGIT35_COPYLOOP:
	lpm	
	adiw	ZL,1
	st	Y, LPMREG
	adiw	YL, 12			; Y to next line
	inc	TMPL
	cpi	TMPL, 5
	brlt	DRAWDIGIT35_COPYLOOP	

DRAWDIGIT35_END:
	pop	TMPH
	pop	TMPL
	pop	ZH
	pop	ZL
	pop	YH
	pop	YL
	ret
	
DIGIT35_0:
	.db	0xEE,0xAA,0xAA,0xAA,0xEE, 0
DIGIT35_1:
	.db	0x44,0xCC,0x44,0x44,0xEE, 0
DIGIT35_2:
	.db	0xEE,0x22,0xEE,0x88,0xEE, 0
DIGIT35_3:
	.db	0xEE,0x22,0x66,0x22,0xEE, 0
DIGIT35_4:
	.db	0xAA,0xAA,0xEE,0x22,0x22, 0
DIGIT35_5:
	.db	0xEE,0x88,0xEE,0x22,0xEE, 0
DIGIT35_6:
	.db	0xEE,0x88,0xEE,0xAA,0xEE, 0
DIGIT35_7:
	.db	0xEE,0x22,0x22,0x22,0x22, 0
DIGIT35_8:
	.db	0xEE,0xAA,0xEE,0xAA,0xEE, 0
DIGIT35_9:
	.db	0xEE,0xAA,0xEE,0x22,0xEE, 0
	
	
	