;***************************************************************************
;* project         : MAHPONG 	                                           *
;*-------------------------------------------------------------------------*
;* program         : wall game submodule				   *
;***************************************************************************
;* file            : wall.inc                              		   *
;* version         : 1.0a                                                  *
;*-------------------------------------------------------------------------*
;* original Date   : 03.05.17    Author: M. Hasenstab                      *
;*                 :                     marcus.hasenstab@jkdesign.de      *
;*-------------------------------------------------------------------------*
;* last change     : 03.05.17    Author: MAH		                   *
;***************************************************************************
;* destination HW  : 8515 plus 2bitvideo DAC	                           *
;* destination SW  : 						           *
;* assembler       : wavrasm					           *
;* language        : assembler for AVR		                           *
;***************************************************************************
;*                      COPYRIGHT (c)  				           *
;***************************************************************************



;***************************************************************************
;*                      WALL VARIABLES                                   *
;***************************************************************************


;***************************************************************************
;*                      WALL CONSTANTS                                   *
;***************************************************************************
;.equ	SPEED_SOCCER	= 1
.equ	WALL_SPEED_X_START = 0
.equ	WALL_SPEED_X_MAX = 4
.equ	WALL_SPEED_X_MIN = -4
.equ	WALL_SPEED_Y_START = -3
;.equ	WALL_GOAL1X	= 0
;.equ	WALL_GOAL2X	= 39
;.equ	WALL_SCOREWIN = 21

;.equ	WALL_BATX1	= 3;
;.equ	WALL_BATYMIN	= 0+3;
.equ	WALL_BATYMAX	= 29-1;
.equ	WALL_BATWIDTH	= 5
.equ	WALL_BATXMIN	= 1;
.equ	WALL_BATXMAX	= 40-WALL_BATWIDTH-1;

.equ	WALL_COURT_LEFT   = 0
.equ	WALL_COURT_RIGHT  = 39
.equ	WALL_COURT_TOP    = 0
.equ	WALL_COURT_BOTTOM = 29

.equ	WALL_LIVES_START = 5

;***************************************************************************
;*                      WALL MENU                                        *
;***************************************************************************
WALL_MENU:

WALL_MENU_PLOTSCREEN:
	sbrs	FLAG_I, 6			; redraw on new menu only
	rjmp	WALL_MENU_PLOTSCREEN_END
	ldi	ZL, low( WALL_SCREEN_MENU*2 )	; plot menu screen
	ldi	ZH, high( WALL_SCREEN_MENU*2 )
	rcall	PLOTSCREEN
	cbr	FLAG_I, (1<<6)
WALL_MENU_PLOTSCREEN_END:
	
WALL_MENU_CHECKSTART:
	sbic	PADDLEPIN, PADDLE1UP
	ret
;	sbic	PADDLEPIN, PADDLE2UP
;	ret



;***************************************************************************
;*                      WALL GAME CODE                                   *
;***************************************************************************
WALL_GAME_SETUP:
	ldi	ZL, low( WALL_SCREEN_COURT*2 )	; plot court screen
	ldi	ZH, high( WALL_SCREEN_COURT*2 )
	rcall	PLOTSCREEN

	ldi	YL, low(BAT1_Y)		; set paddle coordinates in SRAM
	ldi	YH, high(BAT1_Y)
	ldi	TMP, WALL_BATYMAX
	st	Y, TMP

	ldi	YL, low(BAT1_X)		; set paddle coordinates in SRAM
	ldi	YH, high(BAT1_X)
	ldi	TMP, (WALL_BATXMAX-WALL_BATXMIN)/2
	st	Y, TMP

	ldi	YL, low(SCORE1)		; score position
	ldi	YH, high(SCORE1)
ldi	TMP, low(0)
	st	Y+, TMP			; clear score low 
ldi	TMP, high(0)
	st	Y, TMP			;   and high

	ldi	YL, low(LIVES1)		; score position
	ldi	YH, high(LIVES1)
ldi	TMP, WALL_LIVES_START
	st	Y+, TMP			; clear score low 
	st	Y, TMP			;   and high


WALL_MENU_STARTGAME:
	cbr	FLAG_I, (1<<5)		; clear start flag
	ldi	ZL, low( WALL_SCREEN_COURT*2 )	; plot court screen
	ldi	ZH, high( WALL_SCREEN_COURT*2 )
	rcall	PLOTSCREEN
WALL_MENU_STARTGAME_NEW_LIVE:
	cbr	FLAG_I, (1<<4)		; clear new live flag

	clr	TMP			; get rid of the old lives debris
	ldi	VREG2, 25
WALL_MENU_STARTGAME_CLEAR2:
	ldi	VREG1, 1
WALL_MENU_STARTGAME_CLEAR1:
	rcall	SETPIXEL
	inc	VREG1
	cpi	VREG1, 39
	brlt	WALL_MENU_STARTGAME_CLEAR1
	inc	VREG2
	cpi	VREG2, 29
	brlt	WALL_MENU_STARTGAME_CLEAR2

	rcall	WAIT_VSYNC	; synchronise game with screen
	sbis	PADDLEPIN, PADDLE1UP
	rjmp	WALL_MENU_STARTGAME


	ldi	YL, low(BAT1_Y)		; set paddle coordinates in SRAM
	ldi	YH, high(BAT1_Y)
	ldi	TMP, WALL_BATYMAX
	st	Y, TMP
	ldi	YL, low(BAT1_X)		; set paddle coordinates in SRAM
	ldi	YH, high(BAT1_X)
	ldi	TMP, (WALL_BATXMAX-WALL_BATXMIN)/2
	st	Y, TMP

	ldi	TMPL, WALL_SPEED_X_START	; x
	ldi	TMPH, WALL_SPEED_Y_START	; y
	ldi	YL, low(BALLSPEED_X)		; set ball speed in SRAM
	ldi	YH, high(BALLSPEED_X)
	st	Y, TMPL
	ldi	YL, low(BALLSPEED_Y)
	ldi	YH, high(BALLSPEED_Y)
	st	Y, TMPH

	rcall	WALL_DISPLAY_NUMBERS

	
WALL_MENU_STARTGAME_1:
	rcall	WAIT_VSYNC	; synchronise game with screen

	rcall	WALL_DOPADDLE

	sbic	PADDLEPIN, PADDLE1UP
	rjmp	WALL_MENU_STARTGAME_1
	
	ldi	YL, low(BAT1_X)		; set ball coordinates to paddle
	ldi	YH, high(BAT1_X)
	ld	TMP, Y	
	subi	TMP, -2
	lsl	TMP
	lsl	TMP
	ldi	YL, low(BALL_X)			
	ldi	YH, high(BALL_X)
	st	Y, TMP
	ldi	TMP, (29-2)*4
	ldi	YL, low(BALL_Y)
	ldi	YH, high(BALL_Y)
	st	Y, TMP


WALL_GAME_LOOP:
	rcall	WAIT_VSYNC	; synchronise game with screen
	rcall	WAIT_VSYNC	; synchronise game with screen

	rcall	WALL_DOPADDLE	; do paddle
	rcall	WALL_DISPLAY_NUMBERS

	sbis	PADDLEPIN, PADDLE1DOWN	; paddle extra zip
	rcall	WALL_DOPADDLE		; do paddle
	rcall	WALL_DOLIVES
	rcall	WALL_NEWWALL
	
	sbrc	FLAG_I,4	; test new live flag
	rjmp	WALL_MENU_STARTGAME_NEW_LIVE

	sbrc	FLAG_I,5	; test start flag
	rjmp	WALL_MENU_STARTGAME

	
;	rcall	WAIT_VSYNC	; synchronise game with screen
;	rcall	WAIT_VSYNC	; synchronise game with screen
;	rcall	WALL_DOPADDLE	; do paddle

; LREG1 = Ball_X  LREG5 = Ball_X_Old
; LREG2 = Ball_Y  LREG6 = Ball_Y_Old
; LREG3 = BallSpeed_X
; LREG4 = BallSpeed_Y
;PLAYPONG_GETBALL:
	ldi	YL, low(BALL_X)	; get ball coordinates from SRAM
	ldi	YH, high(BALL_X)
	ld	LREG1, Y
	ldi	YL, low(BALL_Y)
	ldi	YH, high(BALL_Y)
	ld	LREG2, Y
	mov	LREG5, LREG1		; old ball position
	mov	LREG6, LREG2
	ldi	YL, low(BALLSPEED_X)	; get ball speed from SRAM
	ldi	YH, high(BALLSPEED_X)
	ld	LREG3, Y
	ldi	YL, low(BALLSPEED_Y)
	ldi	YH, high(BALLSPEED_Y)
	ld	LREG4, Y

;PLAYPONG_CLEARCURRENTBALL_POSITION:
	mov	VREG1, LREG5	; clear ball position on screen
	mov	VREG2, LREG6	
	lsr	VREG1		; the resolution in SRAM is 4times higher than on the screen
	lsr	VREG1		;  thus the shifting
	lsr	VREG2
	lsr	VREG2
	ldi	TMP, 0x00
	rcall	SETPIXEL

;PLAYPONG_CALC_NEW_BALL_POSITION:
WALL_PLAYPONG_CNBP:
	add	LREG1, LREG3	; add x-speed to x-pos
	mov	VREG1, LREG1	; check for obstacle on new position
	mov	VREG2, LREG2	
	lsr	VREG1		
	lsr	VREG1		
	lsr	VREG2
	lsr	VREG2

	rcall	GETPIXEL	; GETPIXEL returns 1 if pixel set
	andi	TMP, 0x03
	breq	WALL_PLAYPONG_CNBP_X1 ; no obstacle, go on!

	rcall	WALL_COLLISION_X ; 

	neg	LREG3		; -> obstacle in x direction -> neg x-speed
	add	LREG1, LREG3
	
	rjmp	WALL_PLAYPONG_CNBP	; calc new position with new direction!

WALL_PLAYPONG_CNBP_X1:

	add	LREG2, LREG4	; add y-speed to y-pos
	mov	VREG1, LREG1	; check for obstacle on new position
	mov	VREG2, LREG2	
	lsr	VREG1		
	lsr	VREG1		
	lsr	VREG2
	lsr	VREG2
	rcall	GETPIXEL	; GETPIXEL returns 1 if pixel set
	andi	TMP, 0x03
	breq	WALL_PLAYPONG_CNBP_Y1 ; no obstacle, go on!
	
	rcall	WALL_COLLISION_Y
	
	neg	LREG4		; -> obstacle in y direction -> neg y-speed
	add	LREG2, LREG4

	rjmp	WALL_PLAYPONG_CNBP	; calc new position with new direction!
WALL_PLAYPONG_CNBP_Y1:

;PLAYPONG_SETCURRENTBALL_POSITION:
	mov	VREG1, LREG1	; set ball position on screen
	mov	VREG2, LREG2	
	lsr	VREG1		; the resolution in SRAM is 4times higher than on the screen
	lsr	VREG1		;  thus the shifting
	lsr	VREG2
	lsr	VREG2
	ldi	TMP, 0x03
	rcall	SETPIXEL

;PLAYPONG_SETBALL:
	ldi	YL, low(BALL_X)		; set ball coordinates in SRAM
	ldi	YH, high(BALL_X)
	st	Y, LREG1
	ldi	YL, low(BALL_Y)
	ldi	YH, high(BALL_Y)
	st	Y, LREG2
	ldi	YL, low(BALLSPEED_X)	; set ball speed in SRAM
	ldi	YH, high(BALLSPEED_X)
	st	Y, LREG3
	ldi	YL, low(BALLSPEED_Y)
	ldi	YH, high(BALLSPEED_Y)
	st	Y, LREG4

	rjmp	WALL_GAME_LOOP
	ret	

; collision in x-direction:
WALL_COLLISION_X:
	cpi	VREG1, WALL_COURT_LEFT+1 ; check playcourt boundary
	brge	WALL_COLLISION_X_1
	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_WALL*2)
	ldi	TMPL, low(WALL_SOUND_WALL*2)
	rcall	STARTSOUND
	ret
WALL_COLLISION_X_1:	
	cpi	VREG1, WALL_COURT_RIGHT
	brlt	WALL_COLLISION_X_2
	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_WALL*2)
	ldi	TMPL, low(WALL_SOUND_WALL*2)
	rcall	STARTSOUND
	ret
WALL_COLLISION_X_2:	
	ldi	TMP, 0x00		; remove brick
	rcall	SETPIXEL
	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_BRICK*2)
	ldi	TMPL, low(WALL_SOUND_BRICK*2)
	rcall	STARTSOUND
	rcall	WALL_INC_SCORE
	ret
			
; collision in y-direction:
WALL_COLLISION_Y:
	cpi	VREG2, WALL_COURT_TOP+1 ; check playcourt boundary
	brge	WALL_COLLISION_Y_1

	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_WALL*2)
	ldi	TMPL, low(WALL_SOUND_WALL*2)
	rcall	STARTSOUND
	ret
WALL_COLLISION_Y_1:
	cpi	VREG2, WALL_COURT_TOP+18 ; check playcourt boundary
	brge	WALL_COLLISION_Y_4

	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_BRICK*2)
	ldi	TMPL, low(WALL_SOUND_BRICK*2)
	rcall	STARTSOUND

	ldi	TMP, 0x00		; remove brick
	rcall	SETPIXEL
	rcall	WALL_INC_SCORE

	ret		
WALL_COLLISION_Y_4:
	cpi	VREG2, 28 ; check bat contact
	brne	WALL_COLLISION_Y_3
	ldi	YL, low(BAT1_X)		; get paddle x coordinate from SRAM
	ldi	YH, high(BAT1_X)
	ld	TMP, Y
;	ldi	YL, low(BALLSPEED_X)	; adjust ballspeed x on bat contact
;	ldi	YH, high(BALLSPEED_X)

	mov	TMPL, VREG1		; compare positions -2..0..+2
	sub	TMPL, TMP
	cpi	TMPL, 0
	brlt	WALL_COLLISION_Y_31
	cpi	TMPL, 5
	brge	WALL_COLLISION_Y_31
	subi	TMPL, 2
	mov	LREG3, TMPL		; store new ball speed	
	
	cpi	TMPL,-2			; adjust y-speed as well
	brne	WALL_COLLISION_Y_41
	ldi	TMPL, -1
WALL_COLLISION_Y_41:
	cpi	TMPL,-1
	brne	WALL_COLLISION_Y_42
	ldi	TMPL, -2
WALL_COLLISION_Y_42:
	cpi	TMPL,0
	brne	WALL_COLLISION_Y_43
	ldi	TMPL, -3
WALL_COLLISION_Y_43:
	cpi	TMPL,1
	brne	WALL_COLLISION_Y_44
	ldi	TMPL, -2
WALL_COLLISION_Y_44:
	cpi	TMPL,2
	brne	WALL_COLLISION_Y_45
	ldi	TMPL, -1
WALL_COLLISION_Y_45:

	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_BAT1*2)
	ldi	TMPL, low(WALL_SOUND_BAT1*2)
	rcall	STARTSOUND

WALL_COLLISION_Y_31:
	ret

WALL_COLLISION_Y_3:	
	cpi	VREG2, WALL_COURT_BOTTOM
	brlt	WALL_COLLISION_Y_2
	ldi	YL, low(LIVES1)		; one live less
	ldi	YH, high(LIVES1)
	ld	TMP, Y
	dec	TMP
	st	Y, TMP			
	sbr	FLAG_I, (1<<4)		; set new live flag
WALL_COLLISION_Y_2:	
	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_MISS*2)
	ldi	TMPL, low(WALL_SOUND_MISS*2)
	rcall	STARTSOUND
	ret


WALL_INC_SCORE:
	ldi	YL, low(SCORE1)		; score position
	ldi	YH, high(SCORE1)
	ld	TMPL, Y+
	ld	TMPH, Y
	ldi	TMP, 1
	add	TMPL, TMP
	adc	TMPH, ZEROREG
	st	Y, TMPH
	st	-Y, TMPL
	ret


;***************************************************************************
WALL_DOPADDLE:
	ldi	YL, low(BAT1_Y)	; get paddle coordinates from SRAM
	ldi	YH, high(BAT1_Y)
	ld	VREG2, Y
	ldi	YL, low(BAT1_X)	; get paddle coordinates from SRAM
	ldi	YH, high(BAT1_X)
	ld	VREG1, Y

WALL_DOPADDLE1_ERASE:
	ldi	TMP, 0x00	; color black
	ldi	TMPL, 0
WALL_DOPADDLE1_ERASE_1:
	rcall	SETPIXEL
	inc	VREG1
	inc	TMPL
	cpi	TMPL, WALL_BATWIDTH
	brlt	WALL_DOPADDLE1_ERASE_1
	subi	VREG1, WALL_BATWIDTH

	sbis	PADDLEPIN, PADDLE1LEFT	; paddle movement
	dec	VREG1
	sbis	PADDLEPIN, PADDLE1RIGHT
	inc	VREG1
	cpi	VREG1, WALL_BATXMIN		; check lower limit
	brge	WALL_DOPADDLE1_1
	ldi	VREG1, WALL_BATXMIN
WALL_DOPADDLE1_1:
	cpi	VREG1, WALL_BATXMAX		; check upper limit
	brlt	WALL_DOPADDLE1_2
	ldi	VREG1, WALL_BATXMAX
WALL_DOPADDLE1_2:
	ldi	YL, low(BAT1_X)		; set paddle x coordinate in SRAM
	ldi	YH, high(BAT1_X)
	st	Y, VREG1

WALL_DOPADDLE1_DRAW:
	ldi	TMP, 0x02		; color light grey
	ldi	TMPL, 0
WALL_DOPADDLE1_DRAW_1:
	rcall	SETPIXEL
	inc	VREG1
	inc	TMPL
	cpi	TMPL, WALL_BATWIDTH
	brlt	WALL_DOPADDLE1_DRAW_1
	ret
;***************************************************************************
WALL_DOLIVES:
	ldi	YL, low(LIVES1)		; check alive
	ldi	YH, high(LIVES1)
	ld	TMP, Y
	cpse	TMP, ZEROREG		; when live == 0 -> then we're dead
	ret

	push	ZL
	push	ZH
	ldi	ZL, low( WALL_SCREEN_OVER*2 )
	ldi	ZH, high( WALL_SCREEN_OVER*2 )
	rcall	PLOTSCREEN
	pop	ZL
	pop	ZH
	
	rcall	WALL_DISPLAY_NUMBERS

	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_OVER*2)
	ldi	TMPL, low(WALL_SOUND_OVER*2)
	rcall	STARTSOUND

WALL_DOLIVES_FE:
	rcall	WAIT_VSYNC		
	sbic	PADDLEPIN, PADDLE1DOWN
	rjmp	WALL_DOLIVES_FE
	rjmp	RESET
;***************************************************************************


WALL_NEWWALL:
;	push	TMP
	push	TMPL
	push	TMPH
	push	ZL
	push	ZH
	push	VREG1
	push	VREG2

 	ldi	YL, low(SCORE1)		; get score
	ldi	YH, high(SCORE1)
	ld	TMPL, Y+
	ld	TMPH, Y

	ldi	VREG2,high(304)	; there're 304 bricks, so this should do the trick
	ldi	VREG1, low(304)
WALL_NEWWALL_304:
	sub	TMPL, VREG1
	sbc	TMPH, VREG2	
	breq	WALL_NEWWALL_RENEW
	brsh	WALL_NEWWALL_304

WALL_NEWWALL_END:
	pop	VREG2
	pop	VREG1
	pop	ZH
	pop	ZL
	pop	TMPH
	pop	TMPL
;	pop	TMP	
	ret

WALL_NEWWALL_RENEW:
 	ldi	YL, low(SCORE1)		; get score
	ldi	YH, high(SCORE1)
	ld	TMPL, Y+
	ld	TMPH, Y
	ldi	TMP, 1
	add	TMPL, TMP
	adc	TMPH, ZEROREG
	st	Y, TMPH
	st	-Y, TMPL
	
	ldi	YL, low(LIVES1)		; do bonus live
	ldi	YH, high(LIVES1)
	ld	TMP, Y
	inc	TMP
	st	Y, TMP

	rcall	STOPSOUND
	ldi	TMPH, high(WALL_SOUND_NEWWALL*2)
	ldi	TMPL, low(WALL_SOUND_NEWWALL*2)
	rcall	STARTSOUND

	
	sbr	FLAG_I, (1<<5)		; set start flag
	rjmp	WALL_NEWWALL_END


;***************************************************************************
WALL_DISPLAY_NUMBERS:
	push	TMP
	push	TMPL
	push	TMPH
	push	YL
	push	YH
	push	VREG1
	push	VREG2
	
 	ldi	VREG1, 48		; display lives
 	ldi	VREG2, 11
 	ldi	YL, low(LIVES1)		
	ldi	YH, high(LIVES1)
	ld	TMP, Y
	rcall	DRAWDIGIT35
	
 	ldi	YL, low(SCORE1)		; display score
	ldi	YH, high(SCORE1)
	ld	TMPL, Y+
	ld	TMPH, Y

	clr	TMP			; display 10000s
	ldi	VREG2,high(10000)
	ldi	VREG1, low(10000)
WALL_DISPLAY_NUMBERS_10000:
	sub	TMPL, VREG1
	sbc	TMPH, VREG2	
	inc	TMP
	brsh	WALL_DISPLAY_NUMBERS_10000
	add	TMPL, VREG1	
	adc	TMPH, VREG2
	dec	TMP
 	ldi	VREG1, 44		
 	ldi	VREG2, 5
	rcall	DRAWDIGIT35

	clr	TMP			; display 1000s
	ldi	VREG2,high(1000)
	ldi	VREG1, low(1000)
WALL_DISPLAY_NUMBERS_1000:
	sub	TMPL, VREG1
	sbc	TMPH, VREG2	
	inc	TMP
	brsh	WALL_DISPLAY_NUMBERS_1000
	add	TMPL, VREG1	
	adc	TMPH, VREG2
	dec	TMP
 	ldi	VREG1, 44		
 	ldi	VREG2, 11
	rcall	DRAWDIGIT35

	clr	TMP			; display 100s
	ldi	VREG2,high(100)
	ldi	VREG1, low(100)
WALL_DISPLAY_NUMBERS_100:
	sub	TMPL, VREG1
	sbc	TMPH, VREG2	
	inc	TMP
	brsh	WALL_DISPLAY_NUMBERS_100
	add	TMPL, VREG1	
	adc	TMPH, VREG2
	dec	TMP
 	ldi	VREG1, 44		
 	ldi	VREG2, 17
	rcall	DRAWDIGIT35

	clr	TMP			; display 10s
	ldi	VREG2,high(10)
	ldi	VREG1, low(10)
WALL_DISPLAY_NUMBERS_10:
	sub	TMPL, VREG1
	sbc	TMPH, VREG2	
	inc	TMP
	brsh	WALL_DISPLAY_NUMBERS_10
	add	TMPL, VREG1	
	adc	TMPH, VREG2
	dec	TMP
 	ldi	VREG1, 44		
 	ldi	VREG2, 23
	rcall	DRAWDIGIT35

	mov	TMP, TMPL		; display 1s
 	ldi	VREG1, 44		
 	ldi	VREG2, 29
	rcall	DRAWDIGIT35

	pop	VREG2
	pop	VREG1
	pop	YH
	pop	YL
	pop	TMPH
	pop	TMPL
	pop	TMP	
	ret

;***************************************************************************


;***************************************************************************
;*                      WALL VIDEO PATTERNS                              *
;***************************************************************************

WALL_SCREEN_MENU:
	.db 0x30, 0x10, 0x90, 0x90, 0xD0, 0x20, 0xE0, 0xE0, 0x70, 0x40, 0xB0, 0x80
	.db 0x40, 0xA0, 0x20, 0x40, 0x90, 0xA0, 0x80, 0x40, 0x20, 0x70, 0xA0, 0x00
	.db 0x70, 0xA0, 0xB0, 0xC0, 0x90, 0x60, 0x40, 0x40, 0x20, 0x40, 0xB0, 0x00
	.db 0x40, 0x90, 0xA0, 0x50, 0xD0, 0x20, 0xE0, 0x40, 0x20, 0x40, 0xB0, 0x80
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	.db 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xCF, 0x3F, 0xCF
	.db 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xCF, 0x3F, 0xCF
	.db 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0xFF, 0xF0, 0x0F, 0xF0
	.db 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0xFF, 0xF0, 0x0F, 0xF0
	.db 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xFC, 0xC3, 0x3C, 0xC3, 0x3F, 0xCF, 0x3F
	.db 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xFC, 0xC3, 0x3C, 0xC3, 0x3F, 0xCF, 0x3F
	.db 0x0F, 0xFF, 0x0F, 0xF0, 0xFF, 0xF0, 0xFF, 0x0F, 0xFF, 0xF0, 0xFF, 0xF0
	.db 0x0F, 0xFF, 0x0F, 0xF0, 0xFF, 0xF0, 0xFF, 0x0F, 0xFF, 0xF0, 0xFF, 0xF0
	.db 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	.db 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	.db 0x11, 0x98, 0x11, 0x88, 0x77, 0x88, 0x66, 0x00, 0x66, 0x00, 0x00, 0x80
	.db 0x11, 0x88, 0x19, 0x99, 0xFF, 0xEE, 0x66, 0x00, 0x66, 0x00, 0x00, 0x04
	.db 0x11, 0x88, 0x11, 0x99, 0x88, 0x66, 0x66, 0x20, 0x66, 0x00, 0x80, 0x00
	.db 0x11, 0x88, 0x11, 0x99, 0xA9, 0x66, 0x66, 0x00, 0x66, 0x09, 0x00, 0x20
	.db 0x11, 0x88, 0x11, 0x99, 0x88, 0x66, 0x66, 0x00, 0x66, 0x40, 0x00, 0x04
	.db 0x11, 0x99, 0x99, 0x99, 0xFF, 0xEE, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00
	.db 0x11, 0x99, 0x99, 0x99, 0xFF, 0xEE, 0x66, 0x80, 0x66, 0x00, 0x00, 0x00
	.db 0x11, 0xEE, 0x77, 0x99, 0x88, 0x66, 0x66, 0x00, 0x66, 0x00, 0x00, 0x00
	.db 0x00, 0x66, 0x66, 0x11, 0xA8, 0x66, 0x77, 0xEE, 0x77, 0xEE, 0x10, 0x00
	.db 0x00, 0x66, 0x66, 0x11, 0x89, 0x66, 0x77, 0xEE, 0x77, 0xEE, 0x00, 0x08
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00
	.db 0x10, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00
	.db 0x02, 0x00, 0x04, 0x10, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x02, 0x10
	.db 0x00, 0x00, 0x20, 0x00, 0x11, 0xFF, 0x88, 0x00, 0x00, 0x80, 0x00, 0x02
	.db 0x00, 0x00, 0x00, 0x00, 0x11, 0xFF, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00

WALL_SCREEN_COURT:
	.db 0xC0, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x00
	.db 0xA0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0xC0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0xA0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0xC0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x7C, 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xCF, 0x2D, 0x0E
	.db 0x0F, 0x7C, 0xF3, 0xFC, 0xF3, 0xFC, 0xF3, 0xCF, 0x3F, 0xCF, 0x2D, 0x00
	.db 0x00, 0x78, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0xFF, 0xF0, 0x0F, 0x0E
	.db 0x0E, 0x78, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0xFF, 0xF0, 0x0F, 0x0E
	.db 0x0E, 0x7C, 0xF3, 0xCF, 0x3F, 0xFC, 0xC3, 0x3C, 0xC3, 0x3C, 0xE3, 0x0E
	.db 0x0E, 0x7C, 0xF3, 0xCF, 0x3F, 0xFC, 0xC3, 0x3C, 0xC3, 0x3C, 0xE3, 0x0E
	.db 0x0E, 0x7F, 0x0F, 0xF0, 0xFF, 0xF0, 0xFF, 0x0F, 0xFF, 0xF0, 0xED, 0x0E
	.db 0x0E, 0x7F, 0x0F, 0xF0, 0xFF, 0xF0, 0xFF, 0x0F, 0xFF, 0xF0, 0xED, 0x00
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0E

WALL_SCREEN_OVER:
	.db 0xC0, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x00
	.db 0xA0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0xC0, 0x08, 0x08, 0x40, 0x01, 0x00, 0x10, 0x00, 0x04, 0x00, 0x41, 0x0E
	.db 0xA0, 0x28, 0x20, 0x02, 0x00, 0x10, 0x00, 0x02, 0x00, 0x81, 0x01, 0x0E
	.db 0xC0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x00, 0x38, 0xF3, 0xED, 0xF3, 0xFC, 0xB7, 0xCF, 0x2F, 0xCF, 0x2D, 0x0E
	.db 0x0F, 0x7C, 0xC0, 0x30, 0x00, 0x64, 0x73, 0x03, 0x00, 0xCF, 0x2D, 0x00
	.db 0x00, 0x78, 0x0C, 0x30, 0x02, 0x60, 0x02, 0x30, 0x00, 0xF0, 0x0F, 0x0E
	.db 0x0E, 0x78, 0x0D, 0xF0, 0x02, 0x60, 0x00, 0x30, 0x77, 0xF0, 0x0F, 0x0E
	.db 0x0E, 0x7C, 0xD1, 0x03, 0x00, 0x64, 0x41, 0x30, 0x01, 0x3C, 0xE3, 0x0E
	.db 0x0E, 0x7C, 0xC0, 0x03, 0x22, 0x64, 0x43, 0x30, 0x07, 0x3C, 0xE3, 0x0E
	.db 0x0E, 0x7F, 0x0C, 0x30, 0x22, 0x60, 0x77, 0x03, 0x00, 0xF0, 0xED, 0x0E
	.db 0x0E, 0x7F, 0x0F, 0xF0, 0xFF, 0xF0, 0xFF, 0x0F, 0xFF, 0xF0, 0xED, 0x00
	.db 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x05, 0x08, 0x00, 0x80, 0x10, 0x10, 0x00, 0x10, 0x00, 0x00, 0x01, 0x0E
	.db 0x0A, 0x28, 0x08, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x04, 0x41, 0x0E
	.db 0x05, 0x08, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x0A, 0x28, 0x10, 0xC0, 0x60, 0x30, 0x70, 0xD0, 0xF0, 0x80, 0x01, 0x0E
	.db 0x05, 0x08, 0x70, 0xF0, 0x60, 0x30, 0x70, 0xD0, 0xF0, 0xC0, 0x09, 0x00
	.db 0x0A, 0x09, 0x60, 0x30, 0x60, 0x38, 0x40, 0x10, 0x80, 0xC0, 0x09, 0x0E
	.db 0x05, 0x18, 0x60, 0x38, 0x60, 0x30, 0x70, 0x10, 0xF0, 0x80, 0x01, 0x0E
	.db 0x0A, 0x08, 0x60, 0x30, 0x60, 0x30, 0x70, 0x10, 0xF0, 0x80, 0x81, 0x0E
	.db 0x05, 0x08, 0x60, 0x30, 0x60, 0x30, 0x40, 0x10, 0xB0, 0x02, 0x01, 0x0E
	.db 0x0A, 0x0A, 0x60, 0x30, 0x30, 0x60, 0x40, 0x10, 0x90, 0x80, 0x09, 0x0E
	.db 0x05, 0x08, 0x70, 0xF0, 0x30, 0xE0, 0x70, 0xD0, 0x80, 0xC0, 0x01, 0x00
	.db 0x0A, 0x08, 0x10, 0xC0, 0x10, 0xC0, 0x70, 0xD0, 0x82, 0xC0, 0x41, 0x0E
	.db 0x05, 0x08, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0E
	.db 0x0A, 0x09, 0x40, 0x40, 0x00, 0x18, 0x00, 0x08, 0x02, 0x80, 0x01, 0x0E
	.db 0x05, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x0E
	.db 0x0A, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0E


;***************************************************************************
;*                      WALL SOUND SCORES                                *
;***************************************************************************
WALL_SOUND_BRICK:
	.db tA1,2,tA1,2,0,0

WALL_SOUND_MISS:
	.db tD1,4
	.db tG1,4
	.db tE1,4
	.db 0,0	

WALL_SOUND_WALL:
	.db tF1,2,tF1,2,0,0
	
WALL_SOUND_NEWWALL:
	.db tC1,4
	.db tD1,4
	.db tE1,4
	.db tG1,2
	.db 0,0	

WALL_SOUND_GOAL1:
	.db tC1,4
	.db tD1,4
	.db tE1,4
	.db 0,0	

WALL_SOUND_OVER:
	.db tD1,4
	.db tG1,4
	.db tE1,4
	.db tC1,2
	.db 0,0	

WALL_SOUND_BAT1:
	.db tD1,2,0,0
